package main

import (
	"fmt"

	neuralnetwork "./neuralnetworkbase"
	mat "gonum.org/v1/gonum/mat"
)

func main() {

	dataSet, result := readData("./iris.data")

	sizes := []int{4, 2, 2, 3}
	nn := neuralnetwork.NewNeuralNetwork(sizes)

	for i := 0; i < len(dataSet); i++ {
		fmt.Printf("Dataset[%d]:\n%v\n\n", i, mat.Formatted(dataSet[i], mat.Prefix(""), mat.Excerpt(0)))
		fmt.Printf("Result[%d]:\n%v\n\n", i, mat.Formatted(result[i], mat.Prefix(""), mat.Excerpt(0)))
		nn.Backward(dataSet[i], result[i])
	}

	// data := make([]float64, sizes[0])
	// for i := range data {
	// 	data[i] = rand.Float64()
	// }
	// aIn := mat.NewDense(sizes[0], 1, data)

	max, index := nn.Predict(dataSet[0])

	for i := 0; i < nn.Count; i++ {
		if i > 0 {
			fmt.Printf("Weights:\n%v\n\n", mat.Formatted(nn.Weights[i], mat.Prefix(""), mat.Excerpt(0)))
			fmt.Printf("Biases:\n%v\n\n", mat.Formatted(nn.Biases[i], mat.Prefix(""), mat.Excerpt(0)))
			fmt.Printf("Z:\n%v\n\n", mat.Formatted(nn.Z[i], mat.Prefix(""), mat.Excerpt(0)))
		}
		fmt.Printf("A:\n%v\n\n", mat.Formatted(nn.A[i], mat.Prefix(""), mat.Excerpt(0)))
	}

	fmt.Printf("Resul: %v, %v\n\n", index, max)
}
